#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>
#include "mcga2.h"

#define MAGIC	"NMH"


BITBLK **mcga_load(name)
char   *name;
{
   FILE  *in;
   int   r, c, max, i;
   char  *buf;
   BITBLK  **new;

   if ((buf = (char *) malloc(6400)) == NULL)
	return(NULL);

   if ((in = fopen(name, "rb")) == NULL)
	return(NULL);

   fread(&r, 1, sizeof(r), in);
   fread(&c, 1, sizeof(c), in);
   max = 0;
   while (!feof(in)) {
	fread(buf, 1, r*c, in);
	max++;
	fread(&r, 1, sizeof(r), in);
	fread(&c, 1, sizeof(c), in);
   }
   free(buf);

   clearerr(in);
   rewind(in);

   if ((new = (BITBLK **) malloc(sizeof(char *) * (max+1))) == NULL)
	return(NULL);

   fread(&r, 1, sizeof(r), in);
   fread(&c, 1, sizeof(c), in);
   i = 0;
   while (!feof(in)) {
	if ((new[i] = (BITBLK *) malloc(sizeof(BITBLK))) == NULL)
	   return(NULL);
	if ((new[i]->stream = (char *) malloc(r*c)) == NULL)
	   return(NULL);
	new[i]->rows = r;
	new[i]->cols = c;
	fread(new[i]->stream, 1, r*c, in);
	fread(&r, 1, sizeof(r), in);
	fread(&c, 1, sizeof(c), in);
	i++;
   }
   new[i] = NULL;

   fclose(in);

   return(new);
}


BITBLK **mcga_zload(name)
char  *name;
{
   char  oname[81];
   BITBLK  **new;

   strcpy(oname, name);
   if (strchr(oname, '.'))
	*(strchr(oname, '.')) = 0;
   strcat(oname, ".$$$");

   if (unsqueeze(name, oname) < -1) {
	unlink(oname);
	return(NULL);
   }

   new = mcga_load(oname);
   unlink(oname);
   return(new);
}


int is_zfile(name)
char  *name;
{
   FILE  *test;
   char  magic[4];

   if ((test = fopen(name, "rb")) == NULL)
	return(0);
   fgets(magic, 4, test);
   fclose(test);
   return(!strcmp(magic, MAGIC));
}


void mcga_unload(bmaps)
BITBLK  **bmaps;
{
   int  i;

   for (i=0; bmaps[i] != NULL; i++)
	free(bmaps[i]);
   free(bmaps);
}


BITBLK *mcga_mergebb(bb1, bb2, bg)
BITBLK  *bb1, *bb2;
int   bg;
{
   BITBLK  *new;
   int     i;

   if (bb1->rows != bb2->rows || bb1->cols != bb2->cols)
	return(NULL);

   if ((new = (BITBLK *) malloc(sizeof(BITBLK))) == NULL)
	return(NULL);
   if ((new->stream = (char *) malloc(bb1->rows * bb1->cols)) == NULL)
	return(NULL);
   new->rows = bb1->rows;
   new->cols = bb1->cols;
   for (i=0; i<bb1->cols * bb1->rows; i++)
	if (bb1->stream[i] != bg)
	   new->stream[i] = bb1->stream[i];
	else
	   new->stream[i] = bb2->stream[i];

   return(new);
}


BITBLK *mcga_lrollbb(bb1, bb2, howmany)
BITBLK  *bb1, *bb2;
int   howmany;
{
   BITBLK  *new;
   int     i, j;

   if (bb1->rows != bb2->rows || bb1->cols != bb2->cols)
	return(NULL);

   if ((new = (BITBLK *) malloc(sizeof(BITBLK))) == NULL)
	return(NULL);
   if ((new->stream = (char *) malloc(bb1->rows * bb1->cols)) == NULL)
	return(NULL);
   new->rows = bb1->rows;
   new->cols = bb1->cols;

   for (j=0; j<bb1->rows; j++)
	for (i=0; i<bb1->cols; i++)
	   if (i<bb1->cols-howmany)
		new->stream[j*bb1->cols+i] =
		bb1->stream[j*bb1->cols+i+howmany];
	   else
		new->stream[j*bb1->cols+i] =
		bb2->stream[j*bb1->cols-(bb1->cols-howmany)+i];

   return(new);
}


BITBLK *mcga_rrollbb(bb1, bb2, howmany)
BITBLK  *bb1, *bb2;
int   howmany;
{
   BITBLK  *new;
   int     i, j;

   if (bb1->rows != bb2->rows || bb1->cols != bb2->cols)
	return(NULL);

   if ((new = (BITBLK *) malloc(sizeof(BITBLK))) == NULL)
	return(NULL);
   if ((new->stream = (char *) malloc(bb1->rows * bb1->cols)) == NULL)
	return(NULL);
   new->rows = bb1->rows;
   new->cols = bb1->cols;

   for (j=0; j<bb1->rows; j++)
	for (i=0; i<bb1->cols; i++)
	   if (i<howmany)
		new->stream[j*bb1->cols+i] =
		bb2->stream[j*bb1->cols+(bb1->cols-howmany)+i];
	   else
		new->stream[j*bb1->cols+i] =
		bb1->stream[j*bb1->cols+i-howmany];

   return(new);
}


void mcga_destroybb(bb)
BITBLK  *bb;
{
   free(bb->stream);
   free(bb);
}
